//+------------------------------------------------------------------+
//|                                                  CS_Stoch_EA.mq4 |
//|                                               Erick_Fenstermaker |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Erick_Fenstermaker"
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#include <stderror.mqh>
#include <stdlib.mqh>


//--- input parameters
extern double StopLoss=0;
extern double TakeProfit=40;
input double   LotSize=0.01;
//Sets how far apart the currency strengths need to be before a trade will be placed
extern double gap = 6;
extern int lookBack = 33;

//Stochastic Settings.
extern string st1;//Stochastic Settings
extern int Kperiod = 5;//KPeriod.
extern int Dperiod = 3;//DPeriod.
extern int Slowing = 3;//Slowing.
extern ENUM_MA_METHOD method = 0;//MA Method.
extern string rm1;//Risk Management Settings.

extern int Slippage=30;
extern int MagicSeed=1000;
input string  Password = "HolyGrail";//Please Enter Your Password.
double pips;
int magic=0;



//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
// Determine what a pip is.
   pips =Point; //.00001 or .0001. .001 .01.
   if(Digits==3||Digits==5)
   pips*=10;
//   #include<InitChecks.mqh>
   Comment("Expert Loaded Successfully");
   return(INIT_SUCCEEDED);
  }

//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick(){
CheckForSignal();
}
void CheckForSignal(){
   static datetime candletime = 0;
   if(candletime != Time[0]){


//Gathers the EUR Symbol close values from the past (Base Values)   
double lookBackEURGBP = iOpen("EURGBP",0,1);
double lookBackEURAUD = iOpen("EURAUD",0,1);
double lookBackEURNZD = iOpen("EURNZD",0,1);
double lookBackEURUSD = iOpen("EURUSD",0,1);
double lookBackEURCAD = iOpen("EURCAD",0,1);
double lookBackEURCHF = iOpen("EURCHF",0,1);
double lookBackEURJPY = iOpen("EURJPY",0,1);

//Gathers the GBP Symbol close values from the past (Base Values)   
double lookBackGBPAUD = iOpen("GBPAUD",0,1);
double lookBackGBPNZD = iOpen("GBPNZD",0,1);
double lookBackGBPUSD = iOpen("GBPUSD",0,1);
double lookBackGBPCAD = iOpen("GBPCAD",0,1);
double lookBackGBPCHF = iOpen("GBPCHF",0,1);
double lookBackGBPJPY = iOpen("GBPJPY",0,1);

//Gathers the AUD Symbol close values from the past (Base Values)   
double lookBackAUDNZD = iOpen("AUDNZD",0,1);
double lookBackAUDUSD = iOpen("AUDUSD",0,1);
double lookBackAUDCAD = iOpen("AUDCAD",0,1);
double lookBackAUDCHF = iOpen("AUDCHF",0,1);
double lookBackAUDJPY = iOpen("AUDJPY",0,1);

//Gathers the NZD Symbol close values from the past (Base Values)   
double lookBackNZDUSD = iOpen("NZDUSD",0,1);
double lookBackNZDCAD = iOpen("NZDCAD",0,1);
double lookBackNZDCHF = iOpen("NZDCHF",0,1);
double lookBackNZDJPY = iOpen("NZDJPY",0,1);

//Gathers the USD Symbol close values from the past (Base Values)   
double lookBackUSDCAD = iOpen("USDCAD",0,1);
double lookBackUSDCHF = iOpen("USDCHF",0,1);
double lookBackUSDJPY = iOpen("USDJPY",0,1);

//Gathers the CAD Symbol close values from the past (Base Values)   
double lookBackCADCHF = iOpen("CADCHF",0,1);
double lookBackCADJPY = iOpen("CADJPY",0,1);

//Gathers the CHF Symbol close values from the past (Base Values)   
double lookBackCHFJPY = iOpen("CHFJPY",0,1);


//Gathers the current EUR Symbol Ask Values
double EURGBP = iOpen("EURGBP", 0,lookBack);
double EURAUD = iOpen("EURAUD", 0,lookBack);
double EURNZD = iOpen("EURNZD", 0,lookBack);
double EURUSD = iOpen("EURUSD", 0,lookBack);
double EURCAD = iOpen("EURCAD", 0,lookBack);
double EURCHF = iOpen("EURCHF", 0,lookBack);
double EURJPY = iOpen("EURJPY", 0,lookBack);

//Gathers the current GBP Symbol Ask Values
double GBPAUD = iOpen("GBPAUD", 0,lookBack);
double GBPNZD = iOpen("GBPNZD", 0,lookBack);
double GBPUSD = iOpen("GBPUSD", 0,lookBack);
double GBPCAD = iOpen("GBPCAD", 0,lookBack);
double GBPCHF = iOpen("GBPCHF", 0,lookBack);
double GBPJPY = iOpen("GBPJPY", 0,lookBack);

//Gathers the current AUD Symbol Ask Values
double AUDNZD = iOpen("AUDNZD", 0,lookBack);
double AUDUSD = iOpen("AUDUSD", 0,lookBack);
double AUDCAD = iOpen("AUDCAD", 0,lookBack);
double AUDCHF = iOpen("AUDCHF", 0,lookBack);
double AUDJPY = iOpen("AUDJPY", 0,lookBack);

//Gathers the current NZD Symbol Ask Values
double NZDUSD = iOpen("NZDUSD", 0,lookBack);
double NZDCAD = iOpen("NZDCAD", 0,lookBack);
double NZDCHF = iOpen("NZDCHF", 0,lookBack);
double NZDJPY = iOpen("NZDJPY", 0,lookBack);

//Gathers the current USD Symbol Ask Values
double USDCAD = iOpen("USDCAD", 0,lookBack);
double USDCHF = iOpen("USDCHF", 0,lookBack);
double USDJPY = iOpen("USDJPY", 0,lookBack);

//Gathers the current CAD Symbol Ask Values
double CADCHF = iOpen("CADCHF", 0,lookBack);
double CADJPY = iOpen("CADJPY", 0,lookBack);

//Gathers the current CHF Symbol Ask Values
double CHFJPY = iOpen("CHFJPY", 0,lookBack);


//Calcualtes the percent change from the past open till the current ask of the EUR values
double perEURGBP = ((lookBackEURGBP - EURGBP) + 0.0000000001)/(EURGBP + 0.0000000001)*100;
double perEURAUD = ((lookBackEURAUD - EURAUD) + 0.0000000001)/(EURAUD + 0.0000000001)*100;
double perEURNZD = ((lookBackEURNZD - EURNZD) + 0.0000000001)/(EURNZD + 0.0000000001)*100;
double perEURUSD = ((lookBackEURUSD - EURUSD) + 0.0000000001)/(EURUSD + 0.0000000001)*100;
double perEURCAD = ((lookBackEURCAD - EURCAD) + 0.0000000001)/(EURCAD + 0.0000000001)*100;
double perEURCHF = ((lookBackEURCHF - EURCHF) + 0.0000000001)/(EURCHF + 0.0000000001)*100;
double perEURJPY = ((lookBackEURJPY - EURJPY) + 0.0000000001)/(EURJPY + 0.0000000001)*100;

//Calcualtes the percent change from the past open till the current ask of the GBP values
double perGBPAUD = ((lookBackGBPAUD - GBPAUD) + 0.0000000001)/(GBPAUD + 0.0000000001)*100;
double perGBPNZD = ((lookBackGBPNZD - GBPNZD) + 0.0000000001)/(GBPNZD + 0.0000000001)*100;
double perGBPUSD = ((lookBackGBPUSD - GBPUSD) + 0.0000000001)/(GBPUSD + 0.0000000001)*100;
double perGBPCAD = ((lookBackGBPCAD - GBPCAD) + 0.0000000001)/(GBPCAD + 0.0000000001)*100;
double perGBPCHF = ((lookBackGBPCHF - GBPCHF) + 0.0000000001)/(GBPCHF + 0.0000000001)*100;
double perGBPJPY = ((lookBackGBPJPY - GBPJPY) + 0.0000000001)/(GBPJPY + 0.0000000001)*100;

//Calcualtes the percent change from the past open till the current ask of the AUD values
double perAUDNZD = ((lookBackAUDNZD - AUDNZD) + 0.0000000001)/(AUDNZD + 0.0000000001)*100;
double perAUDUSD = ((lookBackAUDUSD - AUDUSD) + 0.0000000001)/(AUDUSD + 0.0000000001)*100;
double perAUDCAD = ((lookBackAUDCAD - AUDCAD) + 0.0000000001)/(AUDCAD + 0.0000000001)*100;
double perAUDCHF = ((lookBackAUDCHF - AUDCHF) + 0.0000000001)/(AUDCHF + 0.0000000001)*100;
double perAUDJPY = ((lookBackAUDJPY - AUDJPY) + 0.0000000001)/(AUDJPY + 0.0000000001)*100;

//Calcualtes the percent change from the past open till the current ask of the NZD values
double perNZDUSD = ((lookBackNZDUSD - NZDUSD) + 0.0000000001)/(NZDUSD + 0.0000000001)*100;
double perNZDCAD = ((lookBackNZDCAD - NZDCAD) + 0.0000000001)/(NZDCAD + 0.0000000001)*100;
double perNZDCHF = ((lookBackNZDCHF - NZDCHF) + 0.0000000001)/(NZDCHF + 0.0000000001)*100;
double perNZDJPY = ((lookBackNZDJPY - NZDJPY) + 0.0000000001)/(NZDJPY + 0.0000000001)*100;

//Calcualtes the percent change from the past open till the current ask of the USD values
double perUSDCAD = ((lookBackUSDCAD - USDCAD) + 0.0000000001)/(USDCAD + 0.0000000001)*100;
double perUSDCHF = ((lookBackUSDCHF - USDCHF) + 0.0000000001)/(USDCHF + 0.0000000001)*100;
double perUSDJPY = ((lookBackUSDJPY - USDJPY) + 0.0000000001)/(USDJPY + 0.0000000001)*100;

//Calcualtes the percent change from the past open till the current ask of the CAD values
double perCADCHF = ((lookBackCADCHF - CADCHF) + 0.0000000001)/(CADCHF + 0.0000000001)*100;
double perCADJPY = ((lookBackCADJPY - CADJPY) + 0.0000000001)/(CADJPY + 0.0000000001)*100;

//Calcualtes the percent change from the past open till the current ask of the CHF values
double perCHFJPY = ((lookBackCHFJPY - CHFJPY) + 0.0000000001)/(CHFJPY + 0.0000000001)*100;
     
     
//Calculates true strength of the individual currency's
double perEUR = (perEURGBP + perEURAUD + perEURNZD + perEURUSD + perEURCAD + perEURCHF + perEURJPY);
double perGBP = ((-perEURGBP) + perGBPAUD + perGBPNZD + perGBPUSD + perGBPCAD + perGBPCHF + perGBPJPY);     
double perAUD = (((-perEURAUD) + (-perGBPAUD)) + perAUDNZD + perAUDUSD + perAUDCAD + perAUDCHF + perAUDJPY);
double perNZD = (((-perEURNZD) + (-perGBPNZD) + (-perAUDNZD)) + perNZDUSD + perNZDCAD + perNZDCHF + perNZDJPY);
double perUSD = (((-perEURUSD) + (-perGBPUSD) + (-perAUDUSD) + (-perNZDUSD)) + perUSDCAD + perUSDCHF + perUSDJPY);
double perCAD = (((-perEURCAD) + (-perGBPCAD) + (-perAUDCAD) + (-perNZDCAD) + (-perUSDCAD)) + perCADCHF + perCADJPY);
double perCHF = (((-perEURCHF) + (-perGBPCHF) + (-perAUDCHF) + (-perNZDCHF) + (-perUSDCHF) + (-perCADCHF)) + perCHFJPY);
double perJPY = ((-perEURJPY) + (-perGBPJPY) + (-perAUDJPY) + (-perNZDJPY) + (-perUSDJPY) + (-perCADJPY) + (-perCHFJPY));

//Settings for the stochastics      
double currentK = iStochastic(NULL, PERIOD_CURRENT, Kperiod, Dperiod, Slowing, method, 0, MODE_MAIN,1);
double previousK = iStochastic(NULL, PERIOD_CURRENT, Kperiod, Dperiod, Slowing, method, 0, MODE_MAIN,2);
double currentD = iStochastic(NULL, PERIOD_CURRENT, Kperiod, Dperiod, Slowing, method, 0, MODE_SIGNAL,1);
double previousD = iStochastic(NULL, PERIOD_CURRENT, Kperiod, Dperiod, Slowing, method, 0, MODE_SIGNAL,2);

      
      
//+------------------------------------------------------------------+
//|                Purchase or sell the EUR Pairs                    |
//+------------------------------------------------------------------+

//Signals to purchase or sell the EURGBP

//Measures the gap and makes sure its allways a positive number 
   double GbpEurDiff = MathAbs(perGBP - perEUR);
   
      //Enters a buy trade if the conditions are met
      if(perGBP > perEUR && GbpEurDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        EnterTrade(OP_BUY);
        
        
//Measures the gap and makes sure its allways a positive number         
   double EurGbpDiff = MathAbs(perEUR - perGBP);
   
      //Enters a sell trade if the conditions are met
      if(perEUR > perGBP && EurGbpDiff > gap && previousK > previousD && currentK < currentD && currentD > 80)
        EnterTrade(OP_SELL);
        
        
 
//Signals to purchase or sell the EURAUD

//Measures the gap and makes sure its allways a positive number
   double AudEurDiff = MathAbs(perAUD - perEUR);
    
      //Enters a buy trade if the conditions are met
      if(perAUD > perEUR && AudEurDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        EnterTrade(OP_BUY);
        

//Measures the gap and makes sure its allways a positive number        
   double EurAudDiff = MathAbs(perEUR - perAUD);

      //Enters a sell trade if the conditions are met
      if(perEUR > perAUD && EurAudDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        EnterTrade(OP_SELL);
        
       
                 
//Signals to purchase or sell the EURNZD

//Measures the gap and makes sure its allways a positive number 
   double NzdEurDiff = MathAbs(perNZD - perEUR);

      //Enters a buy trade if the conditions are met
      if(perNZD > perEUR && NzdEurDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        EnterTrade(OP_BUY);
        
        
//Measures the gap and makes sure its allways a positive number         
   double EurNzdDiff = MathAbs(perEUR - perNZD);

      //Enters a sell trade if the conditions are met
      if(perEUR > perNZD && EurNzdDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        EnterTrade(OP_SELL);
        
        
        
//Signals to purchase or sell the EURUSD

//Measures the gap and makes sure its allways a positive number
   double UsdEurDiff = MathAbs(perUSD - perEUR);

      //Enters a buy trade if the conditions are met
      if(perUSD > perEUR && UsdEurDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        EnterTrade(OP_BUY);
        
        
//Measures the gap and makes sure its allways a positive number        
   double EurUsdDiff = MathAbs(perEUR - perUSD);

      //Enters a sell trade if the conditions are met
      if(perEUR > perUSD && EurUsdDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        EnterTrade(OP_SELL);
        
        
               
//Signals to purchase or sell the EURCAD

//Measures the gap and makes sure its allways a positive number  
   double CadEurDiff = MathAbs(perCAD - perEUR);
   
      //Enters a buy trade if the conditions are met
      if(perCAD > perEUR && CadEurDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        EnterTrade(OP_BUY);
        
        
//Measures the gap and makes sure its allways a positive number        
   double EurCadDiff = MathAbs(perEUR - perCAD);

      //Enters a sell trade if the conditions are met
      if(perEUR > perCAD && EurCadDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        EnterTrade(OP_SELL);
        
        
                
//Signals to purchase or sell the EURCHF

//Measures the gap and makes sure its allways a positive number 
   double ChfEurDiff = MathAbs(perCHF - perEUR);

      //Enters a buy trade if the conditions are met
      if(perCHF > perEUR && ChfEurDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        EnterTrade(OP_BUY);
        
        
//Measures the gap and makes sure its allways a positive number        
   double EurChfDiff = MathAbs(perEUR - perCHF); 

      //Enters a sell trade if the conditions are met
      if(perEUR > perCHF && EurChfDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        EnterTrade(OP_SELL);
        


//Signals to purchase or sell the EURJPY

//Measures the gap and makes sure its allways a positive number 
   double JpyEurDiff = MathAbs(perJPY - perEUR);

      //Enters a buy trade if the conditions are met
      if(perJPY > perEUR && JpyEurDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        EnterTrade(OP_BUY);
        
        
//Measures the gap and makes sure its allways a positive number         
   double EurJpyDiff = MathAbs(perEUR - perJPY);

      //Enters a sell trade if the conditions are met
      if(perEUR > perJPY && EurJpyDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        EnterTrade(OP_SELL);
        


//+------------------------------------------------------------------+
//|                 Purchase or sell the GBP Pairs                   |
//+------------------------------------------------------------------+
      
//Signals to purchase or sell the GBPAUD

//Measures the gap and makes sure its allways a positive number 
   double AudGbpDiff = MathAbs(perAUD - perGBP);

      //Enters a buy trade if the conditions are met
      if(perAUD > perGBP && AudGbpDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        EnterTrade(OP_BUY);
        

//Measures the gap and makes sure its allways a positive number         
   double GbpAudDiff = MathAbs(perGBP - perAUD);

      //Enters a sell trade if the conditions are met
      if(perGBP > perAUD && GbpAudDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        EnterTrade(OP_SELL);
        
        
            
//Signals to purchase or sell the GBPNZD

//Measures the gap and makes sure its allways a positive number  
   double NzdGbpDiff = MathAbs(perNZD - perGBP);  

      //Enters a buy trade if the conditions are met
      if(perNZD > perGBP && NzdGbpDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        EnterTrade(OP_BUY);
        
        
//Measures the gap and makes sure its allways a positive number          
   double GbpNzdDiff = MathAbs(perGBP - perNZD);  

      //Enters a sell trade if the conditions are met
      if(perGBP > perNZD && GbpNzdDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        EnterTrade(OP_SELL);
        
        
        
//Signals to purchase or sell the GBPUSD

//Measures the gap and makes sure its allways a positive number  
   double UsdGbpDiff = MathAbs(perUSD - perGBP);  

      //Enters a buy trade if the conditions are met
      if(perUSD > perGBP && UsdGbpDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        EnterTrade(OP_BUY);
        
        
//Measures the gap and makes sure its allways a positive number         
   double GbpUsdDiff = MathAbs(perGBP - perUSD);  

      //Enters a sell trade if the conditions are met
      if(perGBP > perUSD && GbpUsdDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        EnterTrade(OP_SELL);
        
        
        
//Signals to purchase or sell the GBPCAD

//Measures the gap and makes sure its allways a positive number  
   double CadGbpDiff = MathAbs(perCAD - perGBP);  

      //Enters a buy trade if the conditions are met
      if(perCAD > perGBP && CadGbpDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        EnterTrade(OP_BUY);
        
        
//Measures the gap and makes sure its allways a positive number          
   double GbpCadDiff = MathAbs(perGBP - perCAD);  

      //Enters a sell trade if the conditions are met
      if(perGBP > perCAD && GbpCadDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        EnterTrade(OP_SELL);
        
        
        
//Signals to purchase or sell the GBPCHF

//Measures the gap and makes sure its allways a positive number 
   double ChfGbpDiff = MathAbs(perCHF - perGBP);  

      //Enters a buy trade if the conditions are met
      if(perCHF > perGBP && ChfGbpDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        EnterTrade(OP_BUY);
        
        
//Measures the gap and makes sure its allways a positive number        
   double GbpChfDiff = MathAbs(perGBP - perCHF);  

      //Enters a sell trade if the conditions are met
      if(perGBP > perCHF && GbpChfDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        EnterTrade(OP_SELL);
        


//Signals to purchase or sell the GBPJPY

//Measures the gap and makes sure its allways a positive number 
   double JpyGbpDiff = MathAbs(perJPY - perGBP);  

      //Enters a buy trade if the conditions are met
      if(perJPY > perGBP && JpyGbpDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        EnterTrade(OP_BUY);
        
 
//Measures the gap and makes sure its allways a positive number        
   double GbpJpyDiff = MathAbs(perGBP - perJPY);  

      //Enters a sell trade if the conditions are met
      if(perGBP > perJPY && GbpJpyDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        EnterTrade(OP_SELL);
        


//+------------------------------------------------------------------+
//|                 Purchase or sell the AUD Pairs                   |
//+------------------------------------------------------------------+
            
//Signals to purchase or sell the AUDNZD

//Measures the gap and makes sure its allways a positive number 
   double NzdAudDiff = MathAbs(perNZD - perAUD);  

      //Enters a buy trade if the conditions are met
      if(perNZD > perAUD && NzdAudDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        EnterTrade(OP_BUY);
        

//Measures the gap and makes sure its allways a positive number         
   double AudNzdDiff = MathAbs(perAUD - perNZD);  

      //Enters a sell trade if the conditions are met
      if(perAUD > perNZD && AudNzdDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        EnterTrade(OP_SELL);
        
        
        
//Signals to purchase or sell the AUDUSD

//Measures the gap and makes sure its allways a positive number 
   double UsdAudDiff = MathAbs(perUSD - perAUD);  

      //Enters a buy trade if the conditions are met
      if(perUSD > perAUD && UsdAudDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        EnterTrade(OP_BUY);
        

//Measures the gap and makes sure its allways a positive number 
   double AudUsdDiff = MathAbs(perAUD - perUSD);  
   
      //Enters a sell trade if the conditions are met
      if(perAUD > perUSD && AudUsdDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        EnterTrade(OP_SELL);
        
        
        
//Signals to purchase or sell the AUDCAD

//Measures the gap and makes sure its allways a positive number 
   double CadAudDiff = MathAbs(perCAD - perAUD);  
   
      //Enters a buy trade if the conditions are met
      if(perCAD > perAUD && CadAudDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        EnterTrade(OP_BUY);
        

//Measures the gap and makes sure its allways a positive number        
   double AudCadDiff = MathAbs(perAUD - perCAD);  

      //Enters a sell trade if the conditions are met
      if(perAUD > perCAD && AudCadDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        EnterTrade(OP_SELL);
        
        
        
//Signals to purchase or sell the AUDCHF

//Measures the gap and makes sure its allways a positive number 
   double ChfAudDiff = MathAbs(perCHF - perAUD);  

      //Enters a buy trade if the conditions are met
      if(perCHF > perAUD && ChfAudDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        EnterTrade(OP_BUY);
        

//Measures the gap and makes sure its allways a positive number        
   double AudChfDiff = perAUD - perCHF;  

      //Enters a sell trade if the conditions are met
      if(perAUD > perCHF && AudChfDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        EnterTrade(OP_SELL);
        


//Signals to purchase or sell the AUDJPY

//Measures the gap and makes sure its allways a positive number 
   double JpyAudDiff = MathAbs(perJPY - perAUD);  

      //Enters a buy trade if the conditions are met
      if(perJPY > perAUD && JpyAudDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        EnterTrade(OP_BUY);
        

//Measures the gap and makes sure its allways a positive number        
   double AudJpyDiff = MathAbs(perAUD - perJPY);  

      //Enters a sell trade if the conditions are met
      if(perAUD > perJPY && AudJpyDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        EnterTrade(OP_SELL);
        
        
        
//+------------------------------------------------------------------+
//|                 Purchase or sell the NZD Pairs                   |
//+------------------------------------------------------------------+    
        
//Signals to purchase or sell the NZDUSD

//Measures the gap and makes sure its allways a positive number 
   double UsdNzdDiff = MathAbs(perUSD - perNZD);  

      //Enters a buy trade if the conditions are met
      if(perUSD > perNZD && UsdNzdDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        EnterTrade(OP_BUY);
        

//Measures the gap and makes sure its allways a positive number         
   double NzdUsdDiff = MathAbs(perNZD - perUSD);  

      //Enters a sell trade if the conditions are met
      if(perNZD > perUSD && NzdUsdDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        EnterTrade(OP_SELL);
        
        
        
//Signals to purchase or sell the NZDCAD

//Measures the gap and makes sure its allways a positive number 
   double CadNzdDiff = MathAbs(perCAD - perNZD);  

      //Enters a buy trade if the conditions are met
      if(perCAD > perNZD && CadNzdDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        EnterTrade(OP_BUY);
        

//Measures the gap and makes sure its allways a positive number        
   double NzdCadDiff = MathAbs(perNZD - perCAD); 

      //Enters a sell trade if the conditions are met
      if(perNZD > perCAD && NzdCadDiff > gap && previousK > previousD && currentK < currentD && currentD > 80)
        EnterTrade(OP_SELL);
        
        
        
//Signals to purchase or sell the NZDCHF

//Measures the gap and makes sure its allways a positive number 
   double ChfNzdDiff = MathAbs(perCHF - perNZD);  

      //Enters a buy trade if the conditions are met
      if(perCHF > perNZD && ChfNzdDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        EnterTrade(OP_BUY);
        

//Measures the gap and makes sure its allways a positive number         
   double NzdChfDiff = MathAbs(perNZD - perCHF);  

      //Enters a sell trade if the conditions are met
      if(perNZD > perCHF && NzdChfDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        EnterTrade(OP_SELL);
        


//Signals to purchase or sell the NZDJPY

//Measures the gap and makes sure its allways a positive number 
   double JpyNzdDiff = MathAbs(perJPY - perNZD);  

      //Enters a buy trade if the conditions are met
      if(perJPY > perNZD && JpyNzdDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        EnterTrade(OP_BUY);
        

//Measures the gap and makes sure its allways a positive number         
   double NzdJpyDiff = MathAbs(perNZD - perJPY);  

      //Enters a sell trade if the conditions are met
      if(perNZD > perJPY && NzdJpyDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        EnterTrade(OP_SELL);
        
        
       
//+------------------------------------------------------------------+
//|                  Purchase or sell the USD Pairs                  |
//+------------------------------------------------------------------+           
        
//Signals to purchase or sell the USDCAD

//Measures the gap and makes sure its allways a positive number 
   double CadUsdDiff = MathAbs(perCAD - perUSD); 

      //Enters a buy trade if the conditions are met
      if(perCAD > perUSD && CadUsdDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        EnterTrade(OP_BUY);
        

//Measures the gap and makes sure its allways a positive number        
   double UsdCadDiff = MathAbs(perUSD - perCAD); 

      //Enters a sell trade if the conditions are met
      if(perUSD > perCAD && UsdCadDiff > gap && previousK > previousD && currentK < currentD && currentD > 80)
        EnterTrade(OP_SELL);
        
        
        
//Signals to purchase or sell the USDCHF

//Measures the gap and makes sure its allways a positive number 
   double ChfUsdDiff = MathAbs(perCHF - perUSD);  

      //Enters a buy trade if the conditions are met
      if(perCHF > perUSD && ChfUsdDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        EnterTrade(OP_BUY);
        
        
//Measures the gap and makes sure its allways a positive number        
   double UsdChfDiff = MathAbs(perUSD - perCHF);  

      //Enters a sell trade if the conditions are met
      if(perUSD > perCHF && UsdChfDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        EnterTrade(OP_SELL);
        


//Signals to purchase or sell the USDJPY

//Measures the gap and makes sure its allways a positive number 
   double JpyUsdDiff = MathAbs(perJPY - perUSD);  

      //Enters a buy trade if the conditions are met
      if(perJPY > perUSD && JpyUsdDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        EnterTrade(OP_BUY);
        

//Measures the gap and makes sure its allways a positive number         
   double UsdJpyDiff = MathAbs(perUSD - perJPY);  
   
      //Enters a sell trade if the conditions are met
      if(perUSD > perJPY && UsdJpyDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        EnterTrade(OP_SELL);
        
        
        
//+------------------------------------------------------------------+
//|                  Purchase or sell the CAD Pairs                  |
//+------------------------------------------------------------------+           
             
//Signals to purchase or sell the CADCHF

//Measures the gap and makes sure its allways a positive number 
   double ChfCadDiff = MathAbs(perCHF - perCAD);  
   
      //Enters a buy trade if the conditions are met
      if(perCHF > perCAD && ChfCadDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        EnterTrade(OP_BUY);
        

//Measures the gap and makes sure its allways a positive number        
   double CadChfDiff = MathAbs(perCAD - perCHF);  

      //Enters a sell trade if the conditions are met
      if(perCAD > perCHF && CadChfDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        EnterTrade(OP_SELL);
        


//Signals to purchase or sell the CADJPY

//Measures the gap and makes sure its allways a positive number 
   double JpyCadDiff = MathAbs(perJPY - perCAD);  

      //Enters a buy trade if the conditions are met
      if(perJPY > perCAD && JpyCadDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        EnterTrade(OP_BUY);
        

//Measures the gap and makes sure its allways a positive number        
   double CadJpyDiff = MathAbs(perCAD - perJPY);  

      //Enters a sell trade if the conditions are met
      if(perCAD > perJPY && CadJpyDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        EnterTrade(OP_SELL);
        
       
//+------------------------------------------------------------------+
//|                 Purchase or sell the CHF Pairs                   |
//+------------------------------------------------------------------+           
             
//Signals to purchase or sell the CHFJPY

//Measures the gap and makes sure its allways a positive number 
   double JpyChfDiff = MathAbs(perJPY - perCHF);  

      //Enters a buy trade if the conditions are met
      if(perJPY > perCHF && JpyChfDiff > gap && previousK < previousD && currentK > currentD && currentD < 20)
        EnterTrade(OP_BUY);
        

//Measures the gap and makes sure its allways a positive number        
   double ChfJpyDiff = MathAbs(perCHF - perJPY);  

      //Enters a sell trade if the conditions are met
      if(perCHF > perJPY && ChfJpyDiff > gap && previousK  >previousD && currentK < currentD && currentD > 80)
        EnterTrade(OP_SELL);
        
        
        candletime=Time[0];
        }
        }
  
   
//+------------------------------------------------------------------+
//|     TRADE PLACING FUNCTION                                       |
//+------------------------------------------------------------------+
void EnterTrade(int type){

   int err=0;
   double price=Bid, sl=0, tp=0;
   if(type == OP_BUY)
      price =Ask;
   //----
   int ticket = OrderSend(Symbol(),type,LotSize,price,Slippage,0,0,"CS_Stoch_EA Trade",magic,0,Magenta); 
   if(ticket > 0){
      if(OrderSelect(ticket,SELECT_BY_TICKET)){
         sl = OrderOpenPrice()+(StopLoss*Point);
         if(StopLoss==0)sl=0;
         tp = OrderOpenPrice()-(TakeProfit*Point);
         if(OrderType()==OP_BUY){
            sl = OrderOpenPrice()-(StopLoss*Point);
            if(StopLoss==0)sl=0;
            tp = OrderOpenPrice()+(TakeProfit*Point);
         }
         if(!OrderModify(ticket,price,sl,tp,0,Magenta)) {
            err = GetLastError();
            Print("Encountered an error during modification!"+(string)err+" "+ErrorDescription(err)  );
         }
      }
      else{//in case it fails to select the order for some reason 
         Print("Failed to Select Order ",ticket);
         err = GetLastError();
         Print("Encountered an error while seleting order "+(string)ticket+" error number "+(string)err+" "+ErrorDescription(err)  );
      }
   }
   else{//in case it fails to place the order and send us back a ticket number.
      err = GetLastError();
      Print("Encountered an error during order placement!"+(string)err+" "+ErrorDescription(err)  );
      if(err==ERR_TRADE_NOT_ALLOWED)MessageBox("You can not place a trade because \"Allow Live Trading\" is not checked in your options. Please check the \"Allow Live Trading\" Box!","Check Your Settings!");
   }
}
int MagicNumberGenerator()
  {
   string mySymbol=StringSubstr(_Symbol,0,6);
   int pairNumber=0;
   int GeneratedNumber=0;
   if(mySymbol=="AUDCAD") pairNumber=1;
   else if(mySymbol == "AUDCHF")    pairNumber=2;
   else if(mySymbol == "AUDJPY")    pairNumber=3;
   else if(mySymbol == "AUDNZD")    pairNumber=4;
   else if(mySymbol == "AUDUSD")    pairNumber=5;
   else if(mySymbol == "CADCHF")    pairNumber=6;
   else if(mySymbol == "CADJPY")    pairNumber=7;
   else if(mySymbol == "CHFJPY")    pairNumber=8;
   else if(mySymbol == "EURAUD")    pairNumber=9;
   else if(mySymbol == "EURCAD")    pairNumber=10;
   else if(mySymbol == "EURCHF")    pairNumber=11;
   else if(mySymbol == "EURGBP")    pairNumber=12;
   else if(mySymbol == "EURJPY")    pairNumber=13;
   else if(mySymbol == "EURNZD")    pairNumber=14;
   else if(mySymbol == "EURUSD")    pairNumber=15;
   else if(mySymbol == "GBPAUD")    pairNumber=16;
   else if(mySymbol == "GBPCAD")    pairNumber=17;
   else if(mySymbol == "GBPCHF")    pairNumber=18;
   else if(mySymbol == "GBPJPY")    pairNumber=19;
   else if(mySymbol == "GBPNZD")    pairNumber=20;
   else if(mySymbol == "GBPUSD")    pairNumber=21;
   else if(mySymbol == "NZDCAD")    pairNumber=22;
   else if(mySymbol == "NZDJPY")    pairNumber=23;
   else if(mySymbol == "NZDCHF")    pairNumber=24;
   else if(mySymbol == "NZDUSD")    pairNumber=25;
   else if(mySymbol == "USDCAD")    pairNumber=26;
   else if(mySymbol == "USDCHF")    pairNumber=27;
   else if(mySymbol == "USDJPY")    pairNumber=28;
   else if(mySymbol == "XAGUSD")    pairNumber=29;
   else if(mySymbol == "XAUUSD")    pairNumber=30;
   else if(mySymbol == "SPX500")    pairNumber=31;
   else if(mySymbol == "AUS200")    pairNumber=32;
   //do the 5 character cfd's
   else mySymbol=StringSubstr(mySymbol,0,5);
   if(mySymbol      == "GER30")     pairNumber=33;
   else if(mySymbol == "FRA40")     pairNumber=34;
   //do the 4 characther cfd's
   else mySymbol=StringSubstr(mySymbol,0,4);
   if(mySymbol == "US30")      pairNumber=35;
   
   GeneratedNumber=MagicSeed+(pairNumber*1000)+_Period;
   return(GeneratedNumber);
   }
  